#!/bin/bash
#
# for CentOS 5.4
#
#   - Anti Virus
#   - Anti Spam
#   - Web Mail
#   - Web UI
#   - Virtual Domain
#   - Submission
#   - Soft Quota
#   - pop3/imap
#   - Maildir
#
#  Postfix + sleep patch
#  Dovecot
#  Postgrey + targrey patch
#  ClamAV
#  ClamSMTP
#  SpamPD
#  PostfixAdmin
#  SquirrelMail
#  Apache
#  PHP
#  MySQL
#
#  ntp
#  screen
#  phpMyAdmin

# add domain_name and host_name setting (sed)
# add password file read permission setting

domain_name='example.jp'
host_name='host.example.jp'
password='pasuwa-do'

# System settings
echo "[System settings]"

# hostname setting
sed -i.orig s/localhost.localdomain/${host_name}/ /etc/sysconfig/network

# SELinux off
/usr/sbin/setenforce 0
sed -i.orig s/SELINUX=enforcing/SELINUX=disable/ /etc/selinux/config

# iptables setting
# system-config-securitylevel-tui
# tcp 25, 587, 110, 143
cp -p /etc/sysconfig/iptables /etc/sysconfig/iptables.orig
cp conf/sysconfig/iptables /etc/sysconfig/
/etc/init.d/iptables restart

# yum setting and add RPMforge ATrpms
yum -y install yum-priorities yum-utils
rpm --import http://dag.wieers.com/rpm/packages/RPM-GPG-KEY.dag.txt
rpm --import http://ATrpms.net/RPM-GPG-KEY.atrpms
rpm -ivh http://apt.sw.be/redhat/el5/en/i386/RPMS.dag/rpmforge-release-0.5.1-1.el5.rf.i386.rpm
mv /etc/yum.repos.d/CentOS-Base.repo /etc/yum.repos.d/CentOS-Base.repo.orig
mv /etc/yum.repos.d/rpmforge.repo /etc/yum.repos.d/rpmforge.repo.orig
cp conf/yum/CentOS-Base.repo conf/yum/rpmforge.repo conf/yum/atrpms.repo /etc/yum.repos.d/

# install build tools
yum -y install rpm-build autoconf automake gcc

# Postfix + sleep patch
echo "[install Postfix]"
## yum -y install postfix
## yumdownloader --noplugins --source postfix
## wget http://k2net.hakuba.jp/pub/postfix-sleep.patch
wget http://k2net.hakuba.jp/pub/postfix-2.3.3-2.1.sleep.src.rpm
rpm -ivh postfix-2.3.3-2.1.sleep.src.rpm
yum -y install db4-devel openldap-devel cyrus-sasl-devel pcre-devel mysql-devel
rpmbuild -ba /usr/src/redhat/SPECS/postfix.spec
yum -y localinstall /usr/src/redhat/RPMS/i386/postfix-2.3.3-2.1.sleep.i386.rpm --nogpgcheck
#/sbin/chkconfig sendmail off
#/usr/sbin/alternatives --set mta /usr/sbin/sendmail.postfix
yum -y remove sendmail
mv /etc/postfix/master.cf /etc/postfix/master.cf.orig
mv /etc/postfix/main.cf /etc/postfix/main.cf.orig
cp conf/postfix/* /etc/postfix/
/usr/sbin/postmap /etc/postfix/reject_client_blackip /etc/postfix/reject_helo /etc/postfix/reject_mx /etc/postfix/reject_ns /etc/postfix/whitelist_client /etc/postfix/whitelist_recipient
# set password
sed -i s/DROWSSAP/${password}/ /etc/postfix/mysql_virtual_alias_maps.cf
sed -i s/DROWSSAP/${password}/ /etc/postfix/mysql_virtual_domains_maps.cf
sed -i s/DROWSSAP/${password}/ /etc/postfix/mysql_virtual_mailbox_maps.cf
/sbin/chkconfig postfix on

# Dovecot
echo "[install Dovecot]"
yum -y remove dovecot
wget http://dl.atrpms.net/all/dovecot-1.1.20-1_98.el5.i386.rpm
wget http://dl.atrpms.net/all/dovecot-sieve-cmu-1.1.8-11.el5.i386.rpm
rpm -ivh dovecot-1.1.20-1_98.el5.i386.rpm
rpm -ivh dovecot-sieve-cmu-1.1.8-11.el5.i386.rpm
cp conf/dovecot/maildirmake.dovecot /usr/local/bin/
mv /etc/dovecot.conf /etc/dovecot.conf.orig
cp conf/dovecot/dovecot.conf conf/dovecot/dovecot-mysql.conf /etc/
# set password
sed -i s/DROWSSAP/${password}/ /etc/dovecot-mysql.conf
/sbin/chkconfig dovecot on

# Postgrey + targrey
echo "[install Postgrey]"
## wget http://apt.sw.be/redhat/el5/en/SRPMS.rpmforge/postgrey-1.32-1.rf.src.rpm
## wget http://k2net.hakuba.jp/pub/targrey-0.31-postgrey-1.32.patch
wget http://k2net.hakuba.jp/pub/postgrey-1.32-1.rf.targrey.src.rpm
rpm -ivh postgrey-1.32-1.rf.targrey.src.rpm
rpmbuild -ba /usr/src/redhat/SPECS/postgrey.spec
yum -y localinstall /usr/src/redhat/RPMS/noarch/postgrey-1.32-1.rf.targrey.noarch.rpm --nogpgcheck
cp conf/postgrey/postgrey /etc/sysconfig/
/sbin/chkconfig postgrey on

# ClamAV
echo "[install ClamAV]"
yum -y install clamd
cp /etc/clamd.conf /etc/clamd.conf.orig
cp conf/clamav/clamd.conf /etc/
/sbin/chkconfig clamd on
freshclam

# ClamSMTP
echo "[install ClamSMTP]"
wget http://www.inet.lt/clamsmtp/clamsmtp-1.10-1.src.rpm
rpm -ivh clamsmtp-1.10-1.src.rpm
rpmbuild -ba --clean /usr/src/redhat/SPECS/clamsmtp.spec
rpm -ivh /usr/src/redhat/RPMS/i386/clamsmtp-1.10-1.i386.rpm
cp conf/clamsmtp/clamsmtpd.conf /etc/
mkdir /var/lib/postfix
chown postfix:postfix /var/lib/postfix
chmod 700 /var/lib/postfix
/sbin/chkconfig --add clamsmtpd
/sbin/chkconfig clamsmtpd on

# Japanized SpamAssassin
echo "[SpamAssassin install]"
yum -y remove spamassassin
wget http://spamassassin.jp/download/sa3.2/packages/rhel/spamassassin-3.2.5-1.jsaug.src.rpm
rpm -ivh spamassassin-3.2.5-1.jsaug.src.rpm
yum -y install openssl-devel perl-Encode-Detect
rpmbuild -ba --clean /usr/src/redhat/SPECS/spamassassin.spec
yum -y install --enablerepo=rpmforge perl-Mail-SPF.noarch perl-Mail-SPF-Query.noarch perl-Razor-Agent razor-agents perl-IP-Country.noarch
rpm -ivh /usr/src/redhat/RPMS/i386/spamassassin-3.2.5-1.jsaug.i386.rpm
cp /etc/mail/spamassassin/local.cf /etc/mail/spamassassin/local.cf.orig
cp conf/spamassassin/local.cf /etc/mail/spamassassin/
cp conf/spamassassin/sa-update-spampd.cron /etc/cron.weekly/
/usr/bin/sa-update
# only use spampd
#/sbin/chkconfig spamassassin on
#/etc/init.d/spamassassin start

# SpamPD
echo "[install SpamPD]"
wget http://www.worlddesign.com/Content/rd/mta/spampd/spampd-2.30.tar.gz
tar -zxf spampd-2.30.tar.gz
cd spampd-2.30
make spampd.8
cd ..
cp -p spampd-2.30/spampd /usr/local/bin/
cp -p spampd-2.30/spampd.8 /usr/local/share/man/man8/
#cp spampd-rh-rc-script /etc/init.d/spampd
cp conf/spampd/spampd /etc/init.d/
/usr/sbin/groupadd spampd
/usr/sbin/useradd -g spampd -d /var/spool/spampd -s /sbin/nologin -M spampd
mkdir /var/spool/spampd
chown spampd:spampd /var/spool/spampd
/sbin/chkconfig --add spampd
/sbin/chkconfig spampd on

# install AMP
echo "[install AMP]"
yum -y install httpd php-mysql php-mbstring php-imap php-mcrypt mysql-server
cp conf/httpd/postfixadmin.conf conf/httpd/squirrelmail.conf /etc/httpd/conf.d/
/sbin/chkconfig httpd on
/sbin/chkconfig mysqld on
/etc/init.d/httpd start
/etc/init.d/mysqld start
# set password
/usr/bin/mysqladmin -u root password ${password}

# PostfixAdmin
echo "[install PostfixAdmin]"
# http://sourceforge.net/projects/postfixadmin/files/postfixadmin/postfixadmin_2.3.tar.gz
wget http://jaist.dl.sourceforge.net/sourceforge/postfixadmin/postfixadmin_2.3.tar.gz
tar -zxf postfixadmin_2.3.tar.gz
cp -p -R postfixadmin-2.3 /usr/share/postfixadmin
chown -R root:apache /usr/share/postfixadmin
cp -p conf/postfixadmin/postfixadmin-mailbox-postcreation.sh conf/postfixadmin/postfixadmin-mailbox-postdeletion.sh /usr/local/bin/
cp /etc/sudoers /etc/sudoers.orig
cp conf/postfixadmin/sudoers /etc/
cp /usr/share/postfixadmin/config.inc.php /usr/share/postfixadmin/config.inc.php.orig
cp conf/postfixadmin/config.inc.php /usr/share/postfixadmin/
# set password
sed s/DROWSSAP/${password}/ conf/postfixadmin/postfixadmin.sql | mysql -u root -p${password}
sed -i s/DROWSSAP/${password}/ /usr/share/postfixadmin/config.inc.php
postfixadminpassword=`/usr/bin/php conf/postfixadmin/postfixadminpassword.php ${password}`
sed -i s/changeme/${postfixadminpassword}/ /usr/share/postfixadmin/config.inc.php
# PostfixAdmin mail user
/usr/sbin/groupadd -g 10000 virtualmail
/usr/sbin/useradd -u 10000 -g virtualmail -d /var/spool/mail/virtual -s /sbin/nologin -M virtualmail
mkdir /var/spool/mail/virtual
chown virtualmail:virtualmail /var/spool/mail/virtual
chmod 700 /var/spool/mail/virtual
mkdir /var/spool/mail/deleted-maildirs
chown virtualmail:virtualmail /var/spool/mail/deleted-maildirs
chmod 700 /var/spool/mail/deleted-maildirs
cp conf/httpd/postfixadmin.conf /etc/httpd/conf.d/postfixadmin.conf

# Japanized SquirrelMail
echo "[install SquirrelMail]"
#yum -y install squirrelmail
wget http://www.yamaai-tech.com/~masato/Download/squirrelmail-1.4.20-ja-20100310.tar.gz
wget http://jaist.dl.sourceforge.net/sourceforge/squirrelmail/all_locales-1.4.18-20090526.tar.gz
wget http://www.squirrelmail.org/countdl.php?fileurl=http%3A%2F%2Fwww.squirrelmail.org%2Fplugins%2Fcompatibility-2.0.16-1.0.tar.gz
wget http://www.squirrelmail.org/countdl.php?fileurl=http%3A%2F%2Fwww.squirrelmail.org%2Fplugins%2Fempty_trash-1.4-1.2.2.tar.gz
tar -zxf squirrelmail-1.4.20-ja-20100310.tar.gz
mv squirrelmail-1.4.20-ja /usr/share/squirrelmail
rm -rf /usr/share/squirrelmail/help/
mkdir squirrelmaillocale
cd squirrelmaillocale
tar -zxf ../all_locales-1.4.18-20090526.tar.gz
smpath=/usr/share/squirrelmail/
cp -r -i locale ${smpath}
if [ -d help ]; then
    cp -r -i help ${smpath}
fi
if [ -d images ]; then
    cp -r -i images ${smpath}
fi
cd ..
pushd .
cd /usr/share/squirrelmail/po
./compilepo ja_JP
popd
tar -zxf compatibility-2.0.16-1.0.tar.gz
tar -zxf empty_trash-1.4-1.2.2.tar.gz
mv compatibility empty_trash /usr/share/squirrelmail/plugins/
cp /usr/share/squirrelmail/plugins/empty_trash/config.php.sample /usr/share/squirrelmail/plugins/empty_trash/config.php
mkdir -p /var/lib/squirrelmail/prefs /var/spool/squirrelmail/attach
chown apache:apache /var/lib/squirrelmail/prefs /var/spool/squirrelmail/attach
#2.  Data Directory              : /var/lib/squirrelmail/prefs/
#3.  Attachment Directory        : /var/spool/squirrelmail/attach/
cp /usr/share/squirrelmail/config/config.php /usr/share/squirrelmail/config/config.php.orig
cp conf/squirrelmail/config.php /usr/share/squirrelmail/config/
cp /etc/php.ini /etc/php.ini.orig
cp conf/php/php.ini /etc/
cp conf/httpd/squirrelmail.conf /etc/httpd/conf.d/

# update yum
echo "[update yum]"
# add yum.conf exclude
# exclude=postfix* postfix-pflogsumm* spamassassin* postgrey* clamsmtp*
cp -p /etc/yum.conf /etc/yum.conf.orig
cp conf/yum/yum.conf /etc/
yum -y update
/sbin/chkconfig yum-updatesd on
/etc/init.d/yum-updatesd start

# start daemons
/etc/init.d/postfix start
/etc/init.d/dovecot start
/etc/init.d/postgrey start
/etc/init.d/clamd start
/etc/init.d/clamsmtpd start
/etc/init.d/spampd start
# spampd auto-whitelist owner fix
chown spampd:spampd /var/spool/spampd/auto-whitelist

# etc
echo "[etc]"

# ntp
yum -y install ntp
/usr/sbin/ntpdate 0.centos.pool.ntp.org
/sbin/chkconfig ntpd on
/etc/init.d/ntpd start

# screen
yum -y install screen

# phpMyAdmin
## only work phpMyAdmin-2 on php-5.1
wget http://jaist.dl.sourceforge.net/sourceforge/phpmyadmin/phpMyAdmin-2.11.10-all-languages-utf-8-only.tar.gz
tar -zxf phpMyAdmin-2.11.10-all-languages-utf-8-only.tar.gz
cp -p -R phpMyAdmin-2.11.10-all-languages-utf-8-only /usr/share/phpmyadmin
chown -R root:apache /usr/share/phpmyadmin
#cp config.sample.inc.php config.inc.php
# edit 'blowfish_secret'
cp conf/phpmyadmin/config.inc.php /usr/share/phpmyadmin/
cp conf/httpd/phpmyadmin.conf /etc/httpd/conf.d/

# done
echo "[done]"
